#ifndef __IBEX_SYSTEM_H
#define __IBEX_SYSTEM_H

#include <stdint.h>

#define TIMER_IRQn 7

#define __csrr(csr, val) asm volatile("csrr %0, " csr "\n" : "=r"(val))
#define __csrw(csr, val) asm volatile("csrw " csr ", %0\n" : : "r"(val))
#define __csrs(csr, val) asm volatile("csrs " csr ", %0\n" : : "r"(val))
#define __csrc(csr, val) asm volatile("csrc " csr ", %0\n" : : "r"(val))

void __enable_irqs(void);
void __disable_irqs(void);
void __enable_irqn(int irq_number);
void __enable_mcount(void);
uint64_t __read_mcycle(void);

#endif